﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private FullPath As String
	Private Com As Computer
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub

'Method to drill down directories.
Public Sub AddChild (Folder As String) As DirectoryTools
	FullPath = FullPath & SpecialFolder.Separator & Folder	
	Return Me
End Sub

'Returns the result as a string.
Public Sub ShowResult As String
	Setup
	Dim Output As String = FullPath
	FullPath = ""
	
	Dim LastFolder As String = GetLastItemFromPath(Output)
	Dim ParentDir As String = Output.Replace(LastFolder, "")
	
	Com.DetectOperatngSystem
	If Com.IsWindows And Output.Contains("\C:\\") Then
		Output = Output.Replace("\C:\\", "C:\")
	Else If Com.IsWindows And Output.Contains("\C:\") Then
		Output = Output.Replace("\C:\", "C:\")
	Else If Com.IsMac Or Com.IsLinux And Output.Contains("//") Then
		Output = Output.Replace("//", "/")
	End If
	
	If File.Exists(ParentDir, LastFolder) = True Then
		Return Output
	Else
		Return "Child Does Not Exist!"
	End If
End Sub

'Method to obtain the last file or folder 
Public Sub GetLastItemFromPath (Path As String) As String
   Dim i As Int = Path.LastIndexOf("\")
   If i = -1 Then i = Path.LastIndexOf("/")
   If i = -1 Then Return Path
   If i = Path.Length - 1 Then Return ""
   Return Path.SubString(i + 1)
End Sub

'Deletes a directory; including all files and folders inside the given direcotry.
Public Sub DeleteDir (Dir As String)
	Setup
	Dir = Dir.Replace(" ", "_")
	Com.DetectOperatngSystem
	Com.SetReplaceUnderscores(True)
	If Com.IsWindows = True Then
		Com.Execute("cmd", "rmdir -r /s /q " & """" & Dir & """")
	Else
		Com.Execute("rm", "-r " & """" & Dir & """")
	End If
End Sub

'Moves a directory.
Public Sub MoveDir (OldDir As String, NewDir As String)
	Setup
	Com.DetectOperatngSystem
	Com.SetReplaceUnderscores(True)
	OldDir = OldDir.Replace(" ","_")
	NewDir = NewDir.Replace(" ","_")
	If Com.IsWindows = True Then
		Com.Execute("cmd", "move " & """" & OldDir & """" & " " & """" & NewDir & """")
	Else
		Com.Execute("mv", """" & OldDir & """" & " " & """" & NewDir & """")
	End If
End Sub

'Copies a directory. Thanks to Erel for the Code. 
Private Sub CopyDir(Source As String, targetFolder As String)
   If File.Exists(targetFolder, "") = False Then File.MakeDir(targetFolder, "")
   For Each f As String In File.ListFiles(Source)
     If File.IsDirectory(Source, f) Then
       CopyDir(File.Combine(Source, f), File.Combine(targetFolder, f))
       Continue
     End If
     File.Copy(Source, f, targetFolder, f)
   Next  
End Sub

Private Sub Setup
	Com.Initialize
End Sub