﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
#IgnoreWarnings: 17
Sub Class_Globals
	Private fx As JFX
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
End Sub

Public Sub Reload (Form As Form)
	Form.Close
	Form.Show
End Sub

'Centers the form on screen.
Public Sub CenterForm (Form As Form)
   Dim ps As Screen = fx.PrimaryScreen
   Form.WindowTop = (ps.MaxY - ps.MinY) / 2 - Form.Height / 2
   Form.WindowLeft = (ps.MaxX - ps.MinX) / 2 - Form.Width / 2
End Sub

'Centers a ListView.
Public Sub CenterListView (Form As Form, ListView As ListView)
	ListView.Id = "lv"
	Form.Stylesheets.Add(File.GetUri(File.DirAssets, "center.css"))
End Sub

Public Sub HorizontalListView (ListView As ListView)
	Dim jolv As JavaObject = ListView
	jolv.RunMethod("setOrientation", Array("HORIZONTAL"))
End Sub

'Applies a CSS theme.
'Available themes: caspian, light-metro, dark-metro, light-modena, and dark-modena.
Public Sub SetTheme (Form As Form, Theme As String)
	Theme = Theme.ToLowerCase & ".css"
	LogDebug (Theme)
	Form.Stylesheets.Add(File.GetUri(File.DirAssets, Theme))
End Sub

'Maximizes the form.
Public Sub MaximizeForm (Form As Form)
	Dim mf As JavaObject = Form
	mf.GetFieldJO("stage").RunMethod("setMaximized", Array(True))
End Sub

'Disables a Menu Item
Public Sub DisableMenuItem (TheMenu As MenuBar, Tag As String)
	Dim MenuList As Map
	MenuList.Initialize
	CollectMenuItems(MenuList, TheMenu.Menus)
	Dim DisabledItem As MenuItem = MenuList.Get(Tag)
	DisabledItem.Enabled = False
End Sub

'Enables a Menu Item (ColdBlueLava)
Public Sub EnableMenuItem (TheMenu As MenuBar, Tag As String)
	Dim MenuList As Map
	MenuList.Initialize
	CollectMenuItems(MenuList, TheMenu.Menus)
	Dim EnabledItem As MenuItem = MenuList.Get(Tag)
	EnabledItem.Enabled = True
End Sub

Private Sub CollectMenuItems(Menus As Map, Items As List)
   For Each mi As MenuItem In Items
     If mi.Tag <> Null And mi.Tag <> "" Then Menus.Put(mi.Tag, mi)
     If mi Is Menu Then
       Dim mn As Menu = mi
       CollectMenuItems(Menus, mn.MenuItems)
     End If
   Next
End Sub