﻿Type=StaticCode
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private SteamHome, SteamCommon As String
	Private DT As DirectoryTools
	Private Com As Computer
	Private FT As FormTools
	Private fx As JFX
End Sub

Public Sub Initialize
	
End Sub

Private Sub Setup
	DT.Initialize
	Com.Initialize
	FT.Initialize
End Sub

Public Sub Separator As String
	Return GetSystemProperty("file.separator","")
End Sub

Public Sub Documents As String
	Setup
	Dim ShowResult As String
	If Com.IsWindows = True Then
		If Com.OSVersion > 7 Then
			ShowResult = File.Combine(HomeDir, "Documents")
		Else
			ShowResult = File.Combine(HomeDir, "My Documents")
		End If
	End If
	Return ShowResult
End Sub

Public Sub Videos As String
	Setup
	Dim ShowResult As String
	If Com.IsWindows = True Then
		If Com.OSVersion > 7 Then
			ShowResult = File.Combine(HomeDir, "Videos")
		Else
			ShowResult = File.Combine(HomeDir, "My Videos")
		End If
	End If
	Return ShowResult
End Sub

Public Sub Music As String
	Setup
	Dim ShowResult As String
	If Com.IsWindows = True Then
		If Com.OSVersion > 7 Then
			ShowResult = File.Combine(HomeDir, "Music")
		Else
			ShowResult = File.Combine(HomeDir, "My Music")
		End If
	End If
	Return ShowResult	
End Sub

Public Sub Pictures As String
	Setup
	Dim ShowResult As String
	If Com.IsWindows = True Then
		If Com.OSVersion > 7 Then
			ShowResult = File.Combine(HomeDir, "Pictures")
		Else
			ShowResult = File.Combine(HomeDir, "My Pictures")
		End If
	End If
	Return ShowResult	
End Sub

Public Sub Downloads As String
	Setup
	Dim ShowResult As String
	If Com.IsWindows = True Then
		If Com.OSVersion > 7 Then
			ShowResult = File.Combine(HomeDir, "Downloads")
		Else
			ShowResult = File.Combine(HomeDir, "My Downloads")
		End If
	End If
	Return ShowResult	
End Sub

Public Sub HomeDir As String
	Return GetSystemProperty("user.home","")
End Sub

Public Sub SteamHomeDir As String
	Com.DetectOperatngSystem
	If Com.IsWindows = True Then
		SteamHome = DT.AddChild(ProgramFiles32Bit).AddChild("Steam").ShowResult
	Else If Com.IsLinux = True Then
		SteamHome = DT.AddChild(ProgramFiles32Bit).AddChild("Steam").ShowResult
	Else If Com.IsMac = True Then
		SteamHome = DT.AddChild(ProgramFiles32Bit).AddChild("Steam").ShowResult
	End If
	Return SteamHome
End Sub

Public Sub SteamGamesDir As String
	Setup
	If Com.IsWindows = True Then
		SteamCommon = DT.AddChild(ProgramFiles32Bit).AddChild("Steam").AddChild("steamapps").AddChild("common").ShowResult
	Else If Com.IsLinux = True Then
		SteamCommon = DT.AddChild(SystemRoot).AddChild("~local").AddChild("share").AddChild("steamapps").AddChild("common").ShowResult
	Else If Com.IsMac = True Then
		SteamCommon = DT.AddChild(SystemRoot).AddChild("Library").AddChild("Application Support").AddChild("Steam").AddChild("steamapps").AddChild("common").ShowResult
	End If
	Return SteamCommon	
End Sub

Public Sub GitHub As String
	Return File.Combine(HomeDir, "GitHub")
End Sub

Public Sub SystemRoot As String
	Setup
	Dim Root As String
	Com.DetectOperatngSystem
	If Com.IsWindows = True Then
		Root = "C:\"
	Else
		Root = "/"
	End If
	Return Root	
End Sub

Public Sub WindowsDir As String
	Setup
	If Com.IsWindows = True Then
		Return GetEnvironmentVariable("windir","")
	Else
		Return "OS is not a Windows-based OS"
	End If
End Sub

Public Sub ProgramFiles32Bit As String
	Return ProgramFiles64Bit & " (x86)"
End Sub

Public Sub ProgramFiles64Bit As String
	Return GetEnvironmentVariable("ProgramFiles","")
End Sub

Public Sub StartupFolder As String
	Setup
	Com.DetectOperatngSystem
	If Com.IsWindows Then
		Return DT.AddChild(HomeDir).AddChild("AppData").AddChild("Roaming").AddChild("Microsoft").AddChild("Windows").AddChild("Start Menu").AddChild("Programs").AddChild("Startup").ShowResult
	Else
		Return "Error: Windows isn't the Operating System"
	End If
End Sub